exclude: ^src/gemseo/third_party

repos:

- repo: https://github.com/pre-commit/pre-commit-hooks
  rev: v4.4.0
  hooks:
    - id: trailing-whitespace
    - id: end-of-file-fixer
      exclude: (LICENSES/headers|tests/core/data/factory/.*\.json)
    - id: check-yaml
      # !reference is specific to gitlab
      exclude: .gitlab-ci.yml
    - id: check-added-large-files
    - id: check-json
    - id: check-toml
    - id: destroyed-symlinks
    - id: check-symlinks

- repo: https://github.com/pre-commit/pygrep-hooks
  rev: v1.10.0
  hooks:
    - id: rst-backticks
    - id: rst-directive-colons
    - id: rst-inline-touching-normal

- repo: https://github.com/PyCQA/autoflake
  rev: v2.1.1
  hooks:
    - id: autoflake
      args: [
        --in-place,
        --remove-all-unused-imports,
      ]

- repo: https://github.com/asottile/reorder_python_imports
  rev: v3.9.0
  hooks:
    - id: reorder-python-imports
      name: reorder python imports in src
      files: ^src
      args: [
        --application-directories,
        src,
        --py38-plus,
        --add-import,
        "from __future__ import annotations",
      ]
    - id: reorder-python-imports
      name: reorder python imports out of src
      exclude: ^src
      args: [
        --py38-plus,
        --add-import,
        "from __future__ import annotations",
      ]

- repo: https://github.com/myint/docformatter
  rev: v1.6.4
  hooks:
    - id: docformatter
      args: [
        --in-place,
        --wrap-summaries,
        "88",
        --wrap-descriptions,
        "88",
      ]

- repo: https://github.com/asottile/pyupgrade
  rev: v3.3.2
  hooks:
    - id: pyupgrade
      args: [--py38-plus]

- repo: https://github.com/psf/black
  rev: 23.3.0
  hooks:
    - id: black

- repo: https://github.com/PyCQA/flake8
  rev: 6.0.0
  hooks:
    - id: flake8
      additional_dependencies:
        - flake8-bugbear==23.3.23
        - flake8-docstrings==1.7.0
        - flake8-logging-format==0.9.0
        - flake8-print==5.0.0
        - pep8-naming==0.13.3

- repo: https://github.com/commitizen-tools/commitizen
  rev: 3.1.0
  hooks:
    - id: commitizen
      stages: [commit-msg]

- repo: https://github.com/Lucas-C/pre-commit-hooks
  rev: v1.5.1
  hooks:
    - id: insert-license
      name: insert LGPL license
      exclude: ^doc_src
      files: \.py$
      args:
        - --license-filepath
        - LICENSES/headers/LGPL-3.0.txt
    - id: insert-license
      name: insert BSD license
      files: ^doc_src/(_examples|tutorials).*\.py$
      args:
        - --license-filepath
        - LICENSES/headers/BSD-0-Clause.txt
    - id: insert-license
      name: insert CC BY-SA license
      files: (\.rst|\.rst\.txt)$
      exclude: ^changelog/fragments
      args:
        - --license-filepath
        - LICENSES/headers/CC-BY-SA-4.0.txt
        - --comment-style
        - ..|   |
